From e8dd7e60abdc1d08b5d4ad2b798553fc4d71606b Mon Sep 17 00:00:00 2001
From: David Malcolm <dmalcolm@redhat.com>
Date: Tue, 31 Dec 2013 04:51:22 -0500
Subject: [PATCH 037/159] FIXME: emit_barrier_after

---
 gcc/calls.c       | 4 ++--
 gcc/cfgrtl.c      | 5 +++--
 gcc/emit-rtl.c    | 2 +-
 gcc/function.c    | 2 +-
 gcc/haifa-sched.c | 2 +-
 gcc/ifcvt.c       | 3 ++-
 gcc/rtl.h         | 2 +-
 7 files changed, 11 insertions(+), 9 deletions(-)

diff --git a/gcc/calls.c b/gcc/calls.c
index 3963bc2..4d5d8f9 100644
--- a/gcc/calls.c
+++ b/gcc/calls.c
@@ -3232,7 +3232,7 @@ expand_call (tree exp, rtx target, int ignore)
 	     immediately after the CALL_INSN.  Some ports emit more
 	     than just a CALL_INSN above, so we must search for it here.  */
 
-	  rtx last = get_last_insn ();
+	  rtx_base_insn last = get_last_insn ();
 	  while (!CALL_P (last))
 	    {
 	      last = PREV_INSN (last);
@@ -4220,7 +4220,7 @@ emit_library_call_value_1 (int retval, rtx orgfun, rtx value,
       /* The barrier note must be emitted
 	 immediately after the CALL_INSN.  Some ports emit more than
 	 just a CALL_INSN above, so we must search for it here.  */
-      rtx last = get_last_insn ();
+      rtx_base_insn last = get_last_insn ();
       while (!CALL_P (last))
 	{
 	  last = PREV_INSN (last);
diff --git a/gcc/cfgrtl.c b/gcc/cfgrtl.c
index 1760272..6aa1417 100644
--- a/gcc/cfgrtl.c
+++ b/gcc/cfgrtl.c
@@ -1942,7 +1942,8 @@ insert_insn_on_edge (rtx pattern, edge e)
 void
 commit_one_edge_insertion (edge e)
 {
-  rtx before = NULL_RTX, after = NULL_RTX, insns, tmp, last;
+  rtx before = NULL_RTX, after = NULL_RTX, insns, tmp;
+  rtx_base_insn last;
   basic_block bb;
 
   /* Pull the insns off the edge now since the edge might go away.  */
@@ -3712,7 +3713,7 @@ fixup_reorder_chain (void)
        bb->aux)
     {
       edge e_fall, e_taken, e;
-      rtx bb_end_insn;
+      rtx_base_insn bb_end_insn;
       rtx ret_label = NULL_RTX;
       basic_block nb;
       edge_iterator ei;
diff --git a/gcc/emit-rtl.c b/gcc/emit-rtl.c
index 6a90c42..6ecc1a5 100644
--- a/gcc/emit-rtl.c
+++ b/gcc/emit-rtl.c
@@ -4431,7 +4431,7 @@ emit_debug_insn_after_noloc (rtx x, rtx after)
    and output it after the insn AFTER.  */
 
 rtx_base_insn
-emit_barrier_after (rtx after)
+emit_barrier_after (rtx_base_insn after)
 {
   rtx_base_insn insn = rtx_alloc (BARRIER)->as_an_rtx_base_insn ();
 
diff --git a/gcc/function.c b/gcc/function.c
index 9406e04..5060e0a 100644
--- a/gcc/function.c
+++ b/gcc/function.c
@@ -6589,7 +6589,7 @@ epilogue_done:
 	  else if (*pdest_bb == NULL)
 	    {
 	      basic_block bb;
-	      rtx start;
+	      rtx_base_insn start;
 
 	      bb = create_basic_block (NULL, NULL, exit_pred);
 	      BB_COPY_PARTITION (bb, e->src);
diff --git a/gcc/haifa-sched.c b/gcc/haifa-sched.c
index f4f414d..4705e02 100644
--- a/gcc/haifa-sched.c
+++ b/gcc/haifa-sched.c
@@ -7513,7 +7513,7 @@ init_before_recovery (basic_block *before_recovery_ptr)
          Between these two blocks recovery blocks will be emitted.  */
 
       basic_block single, empty;
-      rtx x;
+      rtx_base_insn x;
       rtx_code_label label;
 
       /* If the fallthrough edge to exit we've found is from the block we've
diff --git a/gcc/ifcvt.c b/gcc/ifcvt.c
index fdbf58b..8d1cf97 100644
--- a/gcc/ifcvt.c
+++ b/gcc/ifcvt.c
@@ -3699,7 +3699,8 @@ find_cond_trap (basic_block test_bb, edge then_edge, edge else_edge)
     single_succ_edge (test_bb)->flags |= EDGE_FALLTHRU;
   else if (trap_bb == then_bb)
     {
-      rtx lab, newjump;
+      rtx lab;
+      rtx_base_insn newjump;
 
       lab = JUMP_LABEL (jump);
       newjump = emit_jump_insn_after (gen_jump (lab), jump);
diff --git a/gcc/rtl.h b/gcc/rtl.h
index 11dbb16..34e0202 100644
--- a/gcc/rtl.h
+++ b/gcc/rtl.h
@@ -2146,7 +2146,7 @@ extern rtx_base_insn emit_call_insn_after_setloc (rtx, rtx, int);
 extern rtx_base_insn emit_debug_insn_after (rtx, rtx);
 extern rtx_base_insn emit_debug_insn_after_noloc (rtx, rtx);
 extern rtx_base_insn emit_debug_insn_after_setloc (rtx, rtx, int);
-extern rtx_base_insn emit_barrier_after (rtx);
+extern rtx_base_insn emit_barrier_after (rtx_base_insn);
 extern rtx_code_label emit_label_after (rtx_code_label, rtx);
 extern rtx_note emit_note_after (enum insn_note, rtx);
 extern rtx_base_insn emit_insn (rtx);
-- 
1.7.11.7