From 941610a3b4a6ad741d38fb36915faa64e85b73aa Mon Sep 17 00:00:00 2001
From: David Malcolm <dmalcolm@redhat.com>
Date: Tue, 31 Dec 2013 12:57:04 -0500
Subject: [PATCH 046/159] FIXME: various minor type tweaks

---
 gcc/bb-reorder.c  | 2 +-
 gcc/caller-save.c | 2 +-
 gcc/calls.c       | 2 +-
 gcc/cfgexpand.c   | 8 ++++----
 gcc/df-problems.c | 2 +-
 gcc/dwarf2cfi.c   | 2 +-
 gcc/emit-rtl.c    | 2 +-
 gcc/except.c      | 2 +-
 gcc/expmed.c      | 2 +-
 gcc/final.c       | 6 +++---
 gcc/jump.c        | 6 +++---
 11 files changed, 18 insertions(+), 18 deletions(-)

diff --git a/gcc/bb-reorder.c b/gcc/bb-reorder.c
index 94d58a3..9bf06d5 100644
--- a/gcc/bb-reorder.c
+++ b/gcc/bb-reorder.c
@@ -1941,7 +1941,7 @@ find_jump_block (basic_block jump_dest)
 {
   basic_block source_bb = NULL;
   edge e;
-  rtx insn;
+  rtx_base_insn insn;
   edge_iterator ei;
 
   FOR_EACH_EDGE (e, ei, jump_dest->preds)
diff --git a/gcc/caller-save.c b/gcc/caller-save.c
index 3394904..c46b16c 100644
--- a/gcc/caller-save.c
+++ b/gcc/caller-save.c
@@ -417,7 +417,7 @@ setup_save_areas (void)
   int i, j, k, freq;
   HARD_REG_SET hard_regs_used;
   struct saved_hard_reg *saved_reg;
-  rtx insn;
+  rtx_base_insn insn;
   struct insn_chain *chain, *next;
   unsigned int regno;
   HARD_REG_SET hard_regs_to_save, used_regs, this_insn_sets;
diff --git a/gcc/calls.c b/gcc/calls.c
index 4d5d8f9..f889944 100644
--- a/gcc/calls.c
+++ b/gcc/calls.c
@@ -3509,7 +3509,7 @@ expand_call (tree exp, rtx target, int ignore)
 void
 fixup_tail_calls (void)
 {
-  rtx insn;
+  rtx_base_insn insn;
 
   for (insn = get_insns (); insn; insn = NEXT_INSN (insn))
     {
diff --git a/gcc/cfgexpand.c b/gcc/cfgexpand.c
index cdc84de..95ae17d 100644
--- a/gcc/cfgexpand.c
+++ b/gcc/cfgexpand.c
@@ -1966,7 +1966,7 @@ maybe_cleanup_end_of_block (edge e, rtx last)
      normally isn't there in a cleaned CFG), fix it here.  */
   if (BARRIER_P (get_last_insn ()))
     {
-      rtx insn;
+      rtx_base_insn insn;
       remove_edge (e);
       /* Now, we have a single successor block, if we have insns to
 	 insert on the remaining edge we potentially will insert
@@ -2155,7 +2155,7 @@ mark_transaction_restart_calls (gimple stmt)
     {
       struct tm_restart_node *n = (struct tm_restart_node *) *slot;
       tree list = n->label_or_list;
-      rtx insn;
+      rtx_base_insn insn;
 
       for (insn = next_real_insn (get_last_insn ());
 	   !CALL_P (insn);
@@ -3314,7 +3314,7 @@ expand_gimple_stmt (gimple stmt)
   lp_nr = lookup_stmt_eh_lp (stmt);
   if (lp_nr)
     {
-      rtx insn;
+      rtx_base_insn insn;
       for (insn = next_real_insn (last); insn;
 	   insn = next_real_insn (insn))
 	{
@@ -4771,7 +4771,7 @@ avoid_complex_debug_insns (rtx insn, rtx *exp_p, int depth)
 static void
 expand_debug_locations (void)
 {
-  rtx insn;
+  rtx_base_insn insn;
   rtx last = get_last_insn ();
   int save_strict_alias = flag_strict_aliasing;
 
diff --git a/gcc/df-problems.c b/gcc/df-problems.c
index 48ef85e..e86fcc3 100644
--- a/gcc/df-problems.c
+++ b/gcc/df-problems.c
@@ -3786,7 +3786,7 @@ find_memory_stores (rtx x, const_rtx pat ATTRIBUTE_UNUSED,
 void
 simulate_backwards_to_point (basic_block bb, regset live, rtx point)
 {
-  rtx insn;
+  rtx_base_insn insn;
   bitmap_copy (live, df_get_live_out (bb));
   df_simulate_initialize_backwards (bb, live);
 
diff --git a/gcc/dwarf2cfi.c b/gcc/dwarf2cfi.c
index b8e25bc..f2b7316 100644
--- a/gcc/dwarf2cfi.c
+++ b/gcc/dwarf2cfi.c
@@ -2707,7 +2707,7 @@ create_pseudo_cfg (void)
 {
   bool saw_barrier, switch_sections;
   dw_trace_info ti;
-  rtx insn;
+  rtx_base_insn insn;
   unsigned i;
 
   /* The first trace begins at the start of the function,
diff --git a/gcc/emit-rtl.c b/gcc/emit-rtl.c
index 6ecc1a5..1a61991 100644
--- a/gcc/emit-rtl.c
+++ b/gcc/emit-rtl.c
@@ -3306,7 +3306,7 @@ prev_real_insn (rtx insn)
 rtx_call_insn
 last_call_insn (void)
 {
-  rtx insn;
+  rtx_base_insn insn;
 
   for (insn = get_last_insn ();
        insn && !CALL_P (insn);
diff --git a/gcc/except.c b/gcc/except.c
index 76958c8..10cadd6 100644
--- a/gcc/except.c
+++ b/gcc/except.c
@@ -1952,7 +1952,7 @@ can_nonlocal_goto (const_rtx insn)
 static unsigned int
 set_nothrow_function_flags (void)
 {
-  rtx insn;
+  rtx_base_insn insn;
 
   crtl->nothrow = 1;
 
diff --git a/gcc/expmed.c b/gcc/expmed.c
index 612ea35..d2ed139 100644
--- a/gcc/expmed.c
+++ b/gcc/expmed.c
@@ -3833,7 +3833,7 @@ expand_divmod (int rem_flag, enum tree_code code, enum machine_mode mode,
   rtx quotient = 0, remainder = 0;
   rtx last;
   int size;
-  rtx insn;
+  rtx_base_insn insn;
   optab optab1, optab2;
   int op1_is_constant, op1_is_pow2 = 0;
   int max_cost, extra_cost;
diff --git a/gcc/final.c b/gcc/final.c
index 047461f..cc5bc48 100644
--- a/gcc/final.c
+++ b/gcc/final.c
@@ -1651,7 +1651,7 @@ static void
 reemit_insn_block_notes (void)
 {
   tree cur_block = DECL_INITIAL (cfun->decl);
-  rtx insn;
+  rtx_base_insn insn;
   rtx_note note;
 
   insn = get_insns ();
@@ -4254,7 +4254,7 @@ asm_fprintf (FILE *file, const char *p, ...)
 int
 leaf_function_p (void)
 {
-  rtx insn;
+  rtx_base_insn insn;
 
   if (crtl->profile || profile_arc_flag)
     return 0;
@@ -4331,7 +4331,7 @@ only_leaf_regs_used (void)
 static void
 leaf_renumber_regs (rtx first)
 {
-  rtx insn;
+  rtx_base_insn insn;
 
   /* Renumber only the actual patterns.
      The reg-notes can contain frame pointer refs,
diff --git a/gcc/jump.c b/gcc/jump.c
index e3bc6ee..1dc0543 100644
--- a/gcc/jump.c
+++ b/gcc/jump.c
@@ -62,7 +62,7 @@ along with GCC; see the file COPYING3.  If not see
    or even change what is live at any point.
    So perhaps let combiner do it.  */
 
-static void init_label_info (rtx);
+static void init_label_info (rtx_base_insn);
 static void mark_all_labels (rtx_base_insn);
 static void mark_jump_label_1 (rtx, rtx, bool, bool);
 static void mark_jump_label_asm (rtx, rtx);
@@ -182,9 +182,9 @@ make_pass_cleanup_barriers (gcc::context *ctxt)
    notes whose labels don't occur in the insn any more.  */
 
 static void
-init_label_info (rtx f)
+init_label_info (rtx_base_insn f)
 {
-  rtx insn;
+  rtx_base_insn insn;
 
   for (insn = f; insn; insn = NEXT_INSN (insn))
     {
-- 
1.7.11.7